#
# Copyright 2018.  Cumulus Networks, Inc.
#

from cumulus.platforms.accton_as7312_54x import *

class AcctonAS7312_54XSSwitch(cumulus.platform.BCMSwitch):
    ledup = AcctonAS7312LED
    _sfp28 = AcctonAS7312SFP28
    _qsfp28 = AcctonAS7312QSFP28

    has_phy_ucode_mdio = False
    has_phy_ucode_spi_rom = False
    ports = (
        _sfp28(label="1",   serdes=(40,), leds=(1, 0), tx_lane_map=0x0132,
              rx_lane_map=0x2310, tx_polarity_flip=True, rx_polarity_flip=False),
        _sfp28(label="2",   serdes=(41,), leds=None, tx_lane_map=0x0132,
              rx_lane_map=0x2310, tx_polarity_flip=True, rx_polarity_flip=False),
        _sfp28(label="3",   serdes=(42,), leds=None, tx_lane_map=0x0132,
              rx_lane_map=0x2310, tx_polarity_flip=True, rx_polarity_flip=False),
        _sfp28(label="4",   serdes=(43,), leds=None, tx_lane_map=0x0132,
              rx_lane_map=0x2310, tx_polarity_flip=True, rx_polarity_flip=False),
        _sfp28(label="5",   serdes=(48,), leds=(1, 14), tx_lane_map=0x3210,
              rx_lane_map=0x3210, tx_polarity_flip=False, rx_polarity_flip=False),
        _sfp28(label="6",   serdes=(49,), leds=None, tx_lane_map=0x3210,
              rx_lane_map=0x3210, tx_polarity_flip=False, rx_polarity_flip=False),
        _sfp28(label="7",   serdes=(50,), leds=None, tx_lane_map=0x3210,
              rx_lane_map=0x3210, tx_polarity_flip=False, rx_polarity_flip=False),
        _sfp28(label="8",   serdes=(51,), leds=None, tx_lane_map=0x3210,
              rx_lane_map=0x3210, tx_polarity_flip=False, rx_polarity_flip=False),
        _sfp28(label="9",   serdes=(52,), leds=(1, 28), tx_lane_map=0x3210,
              rx_lane_map=0x3210, tx_polarity_flip=False, rx_polarity_flip=False),
        _sfp28(label="10",  serdes=(53,), leds=None, tx_lane_map=0x3210,
              rx_lane_map=0x3210, tx_polarity_flip=False, rx_polarity_flip=False),
        _sfp28(label="11",  serdes=(54,), leds=None, tx_lane_map=0x3210,
              rx_lane_map=0x3210, tx_polarity_flip=False, rx_polarity_flip=False),
        _sfp28(label="12",  serdes=(55,), leds=None, tx_lane_map=0x3210,
              rx_lane_map=0x3210, tx_polarity_flip=False, rx_polarity_flip=False),
        _sfp28(label="13",  serdes=(64,), leds=(1, 42), tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=False, rx_polarity_flip=False),
        _sfp28(label="14",  serdes=(65,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=False, rx_polarity_flip=False),
        _sfp28(label="15",  serdes=(66,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=False, rx_polarity_flip=False),
        _sfp28(label="16",  serdes=(67,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=False, rx_polarity_flip=False),
        _sfp28(label="17",  serdes=(32,), leds=(1, 56), tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=True, rx_polarity_flip=True,),
        _sfp28(label="18",  serdes=(33,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=True, rx_polarity_flip=True,),
        _sfp28(label="19",  serdes=(34,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=True, rx_polarity_flip=True,),
        _sfp28(label="20",  serdes=(35,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=True, rx_polarity_flip=True,),
        _sfp28(label="21",  serdes=(36,), leds=(1, 70), tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=False, rx_polarity_flip=True,),
        _sfp28(label="22",  serdes=(37,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=True,  rx_polarity_flip=True,),
        _sfp28(label="23",  serdes=(38,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=False, rx_polarity_flip=True,),
        _sfp28(label="24",  serdes=(39,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=True,  rx_polarity_flip=True,),
        _sfp28(label="25",  serdes=(68,), leds=(1, 84),  tx_lane_map=0x0123,
               rx_lane_map=0x3210, tx_polarity_flip=True, rx_polarity_flip=False,),
        _sfp28(label="26",  serdes=(69,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x3210, tx_polarity_flip=True, rx_polarity_flip=False,),
        _sfp28(label="27",  serdes=(70,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x3210, tx_polarity_flip=True, rx_polarity_flip=False,),
        _sfp28(label="28",  serdes=(71,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x3210, tx_polarity_flip=True, rx_polarity_flip=False,),
        _sfp28(label="29",  serdes=(80,), leds=(1, 98), tx_lane_map=0x0123,
               rx_lane_map=0x1032, tx_polarity_flip=True, rx_polarity_flip=True,),
        _sfp28(label="30",  serdes=(81,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x1032, tx_polarity_flip=True, rx_polarity_flip=False,),
        _sfp28(label="31",  serdes=(82,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x1032, tx_polarity_flip=True, rx_polarity_flip=True,),
        _sfp28(label="32",  serdes=(83,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x1032, tx_polarity_flip=True, rx_polarity_flip=False,),
        _sfp28(label="33",  serdes=(84,), leds=(1, 112), tx_lane_map=0x2301,
               rx_lane_map=0x2301, tx_polarity_flip=True,  rx_polarity_flip=True,),
        _sfp28(label="34",  serdes=(85,), leds=None, tx_lane_map=0x2301,
               rx_lane_map=0x2301, tx_polarity_flip=True, rx_polarity_flip=False,),
        _sfp28(label="35",  serdes=(86,), leds=None, tx_lane_map=0x2301,
               rx_lane_map=0x2301, tx_polarity_flip=True,  rx_polarity_flip=True,),
        _sfp28(label="36",  serdes=(87,), leds=None, tx_lane_map=0x2301,
               rx_lane_map=0x2301, tx_polarity_flip=True,  rx_polarity_flip=True,),
        _sfp28(label="37",  serdes=(96,), leds=(0, 0), tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=True, rx_polarity_flip=False,),
        _sfp28(label="38",  serdes=(97,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=True, rx_polarity_flip=False,),
        _sfp28(label="39",  serdes=(98,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=True, rx_polarity_flip=True,),
        _sfp28(label="40",  serdes=(99,), leds=None, tx_lane_map=0x0123,
               rx_lane_map=0x0123, tx_polarity_flip=True, rx_polarity_flip=False,),
        _sfp28(label="41",  serdes=(100,), leds=(0, 14), tx_lane_map=0x3210,
               rx_lane_map=0x3210, tx_polarity_flip=False, rx_polarity_flip=False,),
        _sfp28(label="42",  serdes=(101,), leds=None, tx_lane_map=0x3210,
               rx_lane_map=0x3210, tx_polarity_flip=False, rx_polarity_flip=False,),
        _sfp28(label="43",  serdes=(102,), leds=None, tx_lane_map=0x3210,
               rx_lane_map=0x3210, tx_polarity_flip=False, rx_polarity_flip=False,),
        _sfp28(label="44",  serdes=(103,), leds=None, tx_lane_map=0x3210,
               rx_lane_map=0x3210, tx_polarity_flip=False, rx_polarity_flip=False,),
        _sfp28(label="45",  serdes=(104,), leds=(0, 28), tx_lane_map=0x1032,
               rx_lane_map=0x1032, tx_polarity_flip=False, rx_polarity_flip=False,),
        _sfp28(label="46",  serdes=(105,), leds=None, tx_lane_map=0x1032,
               rx_lane_map=0x1032, tx_polarity_flip=False, rx_polarity_flip=False,),
        _sfp28(label="47",  serdes=(106,), leds=None, tx_lane_map=0x1032,
               rx_lane_map=0x1032, tx_polarity_flip=False, rx_polarity_flip=False,),
        _sfp28(label="48",  serdes=(107,), leds=None, tx_lane_map=0x1032,
               rx_lane_map=0x1032, tx_polarity_flip=False, rx_polarity_flip=False,),

        _qsfp28(label="49", serdes=(  4,   5,   6,   7), leds=(0, 42),
              tx_polarity_flip=0x0000, rx_polarity_flip=0x0000,
              tx_lane_map=0x3210, rx_lane_map=0x3210),
        _qsfp28(label="50", serdes=(  0,   1,   2,   3), leds=(0, 56),
              tx_polarity_flip=0x0000, rx_polarity_flip=0x0000,
              tx_lane_map=0x3210, rx_lane_map=0x3210),
        _qsfp28(label="51", serdes=(108, 109, 110, 111), leds=(0, 70),
              tx_polarity_flip=0x0000, rx_polarity_flip=0x0000,
              tx_lane_map=0x0123, rx_lane_map=0x0123),
        _qsfp28(label="52", serdes=( 20,  21,  22,  23), leds=(0, 84),
              tx_polarity_flip=0x0000, rx_polarity_flip=0x0000,
              tx_lane_map=0x3210, rx_lane_map=0x0213),
        _qsfp28(label="53", serdes=(  8,   9,  10,  11), leds=(0, 98),
              tx_polarity_flip=0x0000, rx_polarity_flip=0x0000,
              tx_lane_map=0x3210, rx_lane_map=0x3210),
        _qsfp28(label="54", serdes=( 116, 117, 118, 119), leds=(0, 112),
              tx_polarity_flip=0x000b, rx_polarity_flip=0x000f,
              tx_lane_map=0x3210, rx_lane_map=0x1230),
    )

class AcctonAS7312_54XS(cumulus.platform.Platform):
    name = 'accton,as7312_54xs'
    chip = cumulus.platform.TomahawkPlus_56967_Chip()
    switch = AcctonAS7312_54XSSwitch(chip)
    cpld = AcctonAS7312_54XCPLD()
    sensors = AcctonAS7312_54XSensors()
    pwms = AcctonAS7312_54XPWMs()
    statusleds = None

Platform = AcctonAS7312_54XS
